C. Mahmoud and a Message----基础DP

C. Mahmoud and a Message
time limit per test
2 seconds
memory limit per test
256 megabytes
input
standard input
output
standard output

Mahmoud wrote a message s of length n. He wants to send it as a birthday present to his friend Moaz who likes strings. He wrote it on a magical paper but he was surprised because some characters disappeared while writing the string. That's because this magical paper doesn't allow character number i in the English alphabet to be written on it in a string of length more than ai. For example, if a1 = 2 he can't write character 'a' on this paper in a string of length 3 or more. String "aa" is allowed while string "aaa" is not.

Mahmoud decided to split the message into some non-empty substrings so that he can write every substring on an independent magical paper and fulfill the condition. The sum of their lengths should be n and they shouldn't overlap. For example, if a1 = 2 and he wants to send string "aaa", he can split it into "a" and "aa" and use 2 magical papers, or into "a", "a" and "a" and use 3 magical papers. He can't split it into "aa" and "aa" because the sum of their lengths is greater than n. He can split the message into single string if it fulfills the conditions.

A substring of string s is a string that consists of some consecutive characters from string s, strings "ab", "abc" and "b" are substrings of string "abc", while strings "acb" and "ac" are not. Any string is a substring of itself.

While Mahmoud was thinking of how to split the message, Ehab told him that there are many ways to split it. After that Mahmoud asked you three questions:

  • How many ways are there to split the string into substrings such that every substring fulfills the condition of the magical paper, the sum of their lengths is n and they don't overlap? Compute the answer modulo 109 + 7.
  • What is the maximum length of a substring that can appear in some valid splitting?
  • What is the minimum number of substrings the message can be spit in?

Two ways are considered different, if the sets of split positions differ. For example, splitting "aa|a" and "a|aa" are considered different splittings of message "aaa".

Input

The first line contains an integer n (1 ≤ n ≤ 103) denoting the length of the message.

The second line contains the message s of length n that consists of lowercase English letters.

The third line contains 26 integers a1, a2, ..., a26 (1 ≤ ax ≤ 103) — the maximum lengths of substring each letter can appear in.

Output

Print three lines.

In the first line print the number of ways to split the message into substrings and fulfill the conditions mentioned in the problem modulo 109  +  7.

In the second line print the length of the longest substring over all the ways.

In the third line print the minimum number of substrings over all the ways.

Examples
input
3
aab
2 3 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1
output
3
2
2
input
10
abcdeabcde
5 5 5 5 4 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1
output
401
4
3
Note

In the first example the three ways to split the message are:

  • a|a|b
  • aa|b
  • a|ab

The longest substrings are "aa" and "ab" of length 2.

The minimum number of substrings is 2 in "a|ab" or "aa|b".

Notice that "aab" is not a possible splitting because the letter 'a' appears in a substring of length 3, while a1 = 2.


题目链接:http://codeforces.com/contest/766/problem/C


好难的DP,在cf最后的一分钟内,狂交3发,最终a了,第七组数据好硬啊,卡了我好几次。。

题目的意思不难理解,是让你分割字符串,但是每个字符所在的字符串不能超过a[i]的数量。


题目一看就知道是个dp,我城阳巨用区间dp没有搞出来,我就随便去dp了,瞎搞一通,加上各种姿势的wa之后,在最后一分钟,终于出来了。


我们设dp[i]数组为在i位置的前缀有多少种分割方式,xin数组为最少分割组数,mix为分割的最大长度,我们易知,dp[0]=1,然后我们的循环从1开始,设l为最小可能的长度,令j为游动指针,每次去judge是否能够分割。然后推到底就可以了。


我刚才去看了看官方题解,思路差不多,略有不同,附上出题大佬的题解:

Let dp[i] be the number of ways to split the prefix of s ending at index i into substrings that fulfills the conditions. Let it be 1-indexed. Our base case is dp[0] = 1. Our answer is dp[n]. Now let's calculate it for every i. Let l be the minimum possible index such that the substring from l to i satisfies the condition, Let x be a moving pointer, At the beginning x = i - 1 and it decreases, Every time we decrease x, We calculate the new value of l depending on the current character like that, l = max(l, i - as[x]). While x is greater than or equal to l we add dp[x] to dp[i]To find the longest substring, Find maximum i - x, To find the minimum number of substrings, there is an easy greedy solution, Find the longest valid prefix and delete it and do the same again until the string is empty, The number of times this operation is repeated is our answer, Or see the dynamic programming solution in the code.


代码:

#include <cstdio>
#include <cstring>
#include <iostream>
#define inf 0x3f3f3f3f
using namespace std;
const int mod=1e9+7;
int dp[3000];
char s[3000];
int a[300];
int xin[3000];
bool judge(int i,int j){//判断是否可以分解,题解上的思路好像比较简单,我的是暴力
	int l=j-i+1;
	for(int k=i;k<=j;k++){
		if(a[s[k]-'a']<l)
		return false;
	}
	return true;
}
int main(){
    int mix=1;
    int n;
    scanf("%d",&n);
    scanf("%s",s+1);
    for(int i=0;i<26;i++)
        scanf("%d",&a[i]);
    memset(dp,0,sizeof(dp));
    dp[0]=1;
    xin[0]=0;
    for(int i=1;i<=n;i++){
        xin[i]=inf;
        for(int j=1;j<=i;j++){//瞎暴力
            int l=i-j+1; 
            if(judge(l,i)){
                dp[i]=(dp[i]+dp[i-j])%mod;
                xin[i]=min(xin[i],xin[i-j]+1);
                if(dp[i-j])
                mix=max(mix,j);
            }
            
        }
    }
    cout<<dp[n]<<endl;
    cout<<mix<<endl;
    cout<<xin[n]<<endl;
    return 0;
}


评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值